
from Globals import Persistent
from Globals import DTMLFile
from Acquisition import Implicit
from OFS.SimpleItem import Item
from OFS.PropertyManager import PropertyManager
import string, urlparse

class LinkedFolder (Implicit, Persistent, Item, PropertyManager):
  """
  Implementation for class LinkedFolder   
  Comparable to a Symbolic Link knwon from Unix/Linux, a LinkedFolder points to a 
  directory with a different name and location.
  """
   
  meta_type='LinkedFolder'
  
  manage_options = (
    {'label': 'Edit',       'action': 'manage_EditForm',
      'help': ('LinkedFolder', 'LinkedFolder_Edit.stx')},
    {'label': 'View',       'action': 'index_html',},
  ) + PropertyManager.manage_options + Item.manage_options
 
  __ac_permissions__=(
       ('View management screens', ('manage_tabs', 'manage_view', 
                                    'manage_EditForm')),
       )
  
  def __init__ (self, id, title, dest):
    "Inits the product with default values"
    self.id    = id
    self.title = title 
    self.dest  = dest

  def __bobo_traverse__ (self, request, name=None):
    if hasattr (self, name):
      # process own attributes/subobjects
      return (getattr (self, name))
    else:
      # redirect traverse to LinkedFolder
      return (getattr (self._getDestObj(), name))

  # def objectValues (self):
    # redirect navigation subdirectories
    #DestObj = self._getDestObj()
    #return (DestObj.objectValues())
    

  def index_html (self, REQUEST={}, RESPONSE=None):
    "Returns index_html from linked Folder"
    DestObj = self._getDestObj()
    if DestObj.meta_type == 'Folder' :
      return (apply (DestObj.index_html, (DestObj, REQUEST)))
    else:
      raise "Linked object is not a Folder", "Type: %s" % DestObj.meta_type
  
  def manage_Add(self, id, RESPONSE=None):
    "Add id"
    self._setObject (id, LinkedFolder(id))
    RESPONSE.redirect ('index_html')
     
  def manage_AddAction (self, id='', title='', dest='', REQUEST=None):
    "Adds the product"
    self._setObject (id, LinkedFolder(id, title, dest))
    if REQUEST is not None:
      return self.manage_main (self, REQUEST)
       
  def manage_EditAction (self, title, dest, RESPONSE=None):
    "Edit prouct values"
    self.title = title
    self.dest  = dest
    self._p_changed = 1
    RESPONSE.redirect ('manage_EditForm')
     
  manage_AddForm  = DTMLFile ('dtml/AddForm', globals())
  manage_EditForm = DTMLFile ('dtml/EditForm', globals())
  
  def _getObjectPath (self):
    """Returns the complete search path from this object"""
    return string.join (self.getPhysicalPath(), ('/'))

  def _getDestPath (self):
    "Return (komplete) Destination Path"
    return (urlparse.urljoin (self._getObjectPath(), self.dest))
    
  def _getDestObj (self):
    return self.restrictedTraverse (self._getDestPath())

  def getDestTitle (self):
    "Return Destination Title"
    try:
      DestTitle = self._getDestObj().title_or_id()
    except:
      DestTitle = '!Destination not found!'
        
    return (DestTitle)
    
